//{$WARNINGS OFF}
//{$WARN SYMBOL_PLATFORM OFF}
//{$WARN UNIT_PLATFORM OFF}
//=============================================================================
//  GDI+ ֌WTv
//  [hWƃy[WW̍Wlϊ
//
//-----------------------------------------------------------------------------
//
//  ygpz
//
//  TCg̃AvP[VށCR|[lgCR[hނ́C]ځCρCzz
//  (IWiCϔ)Ȃǂ͑SĎRłDppRłDACgp̋L
//  ڋ`܂DIWî̂pƂ邱Ƃ͋֎~܂D
//  ȂC{TCg̃vOR[hgpƂɂĐCȂ
//  QCɊւĂ҂͈؊֗^Ȃ̂Ƃ܂DD
//
//-----------------------------------------------------------------------------
//
//  yz
//
//  2012N1209 `
//
//-----------------------------------------------------------------------------
//
//  ymFz
//
//  Windows 7 U64(SP1) + Delphi XE(UP1 Pro
//
//  Presented by Mr.XRAY
//  http://mrxray.on.coocan.jp/
//=============================================================================
unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, StdCtrls, GDIPAPI, GDIPOBJ, ComCtrls;

type
  TMyPanel = class(TPanel)
  private
    FXLocation : Single;
    FYLocation : Single;
    FScale     : Single;
    procedure SetXLocation(const Value: Single);
    procedure SetYLocation(const Value: Single);
    procedure SetScale(const Value: Single);
  protected
    procedure Paint; override;

  public
    constructor Create(AOwner: TComponent); override;
    property XLocation : Single read FXLocation write SetXLocation;
    property YLocation : Single read FYLocation write SetYLocation;
    property Scale     : Single read FScale     write SetScale;
  end;

  TForm1 = class(TForm)
    TrackBar1: TTrackBar;
    TrackBar2: TTrackBar;
    ComboBox1: TComboBox;
    procedure FormCreate(Sender: TObject);
    procedure TrackBar1Change(Sender: TObject);
    procedure TrackBar2Change(Sender: TObject);
    procedure ComboBox1Change(Sender: TObject);
  private
    { Private 錾 }
    MyPanel : TMyPanel;
  public
    { Public 錾 }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

//=============================================================================
//  tH[̏
//=============================================================================
procedure TForm1.FormCreate(Sender: TObject);
begin
  Caption := 'GDI+  [hWn̍Wlɕϊ';

  //`悷Rg[𐶐
  MyPanel := TMyPanel.Create(Self);
  with MyPanel do begin
    Parent := Self;
    SetBounds(5, 70, Self.ClientWidth - 10, Self.ClientHeight - 75);
    DoubleBuffered   := True;
    ControlStyle     := MyPanel.ControlStyle + [csOpaque];
    BevelOuter       := bvNone;
    Visible          := True;
    Color            := clWhite;
    ParentBackground := False;
    Anchors          := [akLeft, akTop, akRight, akBottom];
  end;

  //ւ̌_sړ
  with TrackBar1 do begin
    ShowSelRange := False;
    TickStyle    := tsNone;
    Height   := 26;
    Min      := -250;
    Max      := 250;
    Position := 0;
  end;

  //ւ̌_ړ
  with TrackBar2 do begin
    ShowSelRange := False;
    TickStyle    := tsNone;
    Height   := 26;
    Min      := -150;
    Max      := 150;
    Position := 0;
  end;

  //XP[O
  ComboBox1.Items.Clear;
  ComboBox1.Style := csDropDownList;
  ComboBox1.Items.CommaText := '0.2, 0.5, 1.0, 1.5, 2.0, 2.5, 3.0';
  ComboBox1.ItemIndex := 2;
end;

//=============================================================================
//  TrackBar1OnClickCxg
//  X̍W_̈ړ
//=============================================================================
procedure TForm1.TrackBar1Change(Sender: TObject);
begin
  if not Assigned(MyPanel) then exit;
  MyPanel.XLocation := TrackBar1.Position;
end;

//=============================================================================
//  TrackBar2OnClickCxg
//  Y̍W_̈ړ
//=============================================================================
procedure TForm1.TrackBar2Change(Sender: TObject);
begin
  if not Assigned(MyPanel) then exit;
  MyPanel.YLocation :=  TrackBar2.Position;
end;

//=============================================================================
//  ComboBox1OnClickCxg
//  W̃XP[Oݒ
//=============================================================================
procedure TForm1.ComboBox1Change(Sender: TObject);
begin
  if not Assigned(MyPanel) then exit;
  MyPanel.Scale := StrToFloat(ComboBox1.Items[ComboBox1.ItemIndex]);
end;

{ TMyPanel }

//-----------------------------------------------------------------------------
//  RXgN^
//  evpeB̏
//-----------------------------------------------------------------------------
constructor TMyPanel.Create(AOwner: TComponent);
begin
  inherited;

  FXLocation := 0.0;
  FYLocation := 0.0;
  FScale     := 1.0;
end;

//-----------------------------------------------------------------------------
//  XLocationvpeBݒp\bh
//  X̌_ړ
//-----------------------------------------------------------------------------
procedure TMyPanel.SetXLocation(const Value: Single);
begin
  if not Assigned(Parent) then exit;

  if FXLocation <> Value then begin
     FXLocation := Value;
     Invalidate;
  end;
end;

//-----------------------------------------------------------------------------
//  YLocationvpeBݒp\bh
//  Y̌_ړ
//-----------------------------------------------------------------------------
procedure TMyPanel.SetYLocation(const Value: Single);
begin
  if not Assigned(Parent) then exit;

  if FYLocation <> Value then begin
     FYLocation := Value;
     Invalidate;
  end;
end;

//-----------------------------------------------------------------------------
//  ScalevpeBݒp\bh
//  W̃XP[O
//-----------------------------------------------------------------------------
procedure TMyPanel.SetScale(const Value: Single);
begin
  if not Assigned(Parent) then exit;

  if FScale <> Value then begin
     FScale := Value;
     Invalidate;
  end;
end;

//-----------------------------------------------------------------------------
//  TMyPanelNXPaint\bh
//  ۂ̕`R[h
//-----------------------------------------------------------------------------
procedure TMyPanel.Paint;
var
  LPoints        : array [0..1] of TGPPointF;
  LObjWidth      : Single;
  LObjHeight     : Single;
  LStartX        : Single;
  LStartY        : Single;
  LImageFilePath : String;
  LGPImage       : TGPImage;
  LGPGraphic     : TGPGraphics;
  LGPPen         : TGPPen;
  LObjRect       : TGPRectF;
begin
  inherited;

  //̉w̃TCYł͂ȂCʂ̕ƍŕ`悷
  LObjWidth  := 100.0;
  LObjHeight := 100.0;
  //`n_
  LStartX := 0.0;
  LStartY := 0.0;

  //摜t@CwDTGPImaageCX^X𐶐ēǂݍ
  LImageFilePath := ExtractFilePath(ParamStr(0)) + '503.bmp';
  LGPImage := TGPImage.Create(LImageFilePath);

  //TMyPanelCanvas`ɂTGPGraphics̃CX^X𐶐
  LGPGraphic := TGPGraphics.Create(Canvas.Handle);

  //Ô߃Zbg
  LGPGraphic.ResetTransform;

  //W̌_ (FXLocation, FYLocation) Ɉړ
  //y[WWƌ
  LGPGraphic.TranslateTransform(FXLocation, FYLocation);
  //(X)C(Y)̔{FScale{ɂ
  LGPGraphic.ScaleTransform(FScale, FScale);

  //̐ݒŁC摜IuWFNg`
  LGPGraphic.DrawImage(LGPImage, MakeRect(LStartX, LStartY, LObjWidth, LObjHeight));


  //---------------------------------------------------------------------------
  //  ȉCy[WWn̍Wl[hWn̒lɕϊR[h
  //  摜IuWFNg͂ދ``悷
  //  y[WWn̂܂܂ŕ`悵Ă悢C̃XP[ϊĂƁC
  //  gEkĂ܂
  //---------------------------------------------------------------------------

  //`JnWlƑΊp_̍W̒lzɊi[
  LPoints[0] := MakePoint(0.0, 0.0);
  LPoints[1] := MakePoint(LObjWidth, LObjHeight);

  //[hWn̒lɕϊ
  LGPGraphic.TransformPoints(CoordinateSpacePage,
                             CoordinateSpaceWorld,
                             PGPPointF(@LPoints),
                             Length(LPoints));

  //Wn[hWnɖ߂
  LGPGraphic.ResetTransform;
  //ỹIuWFNgCŎlp``
  LGPPen := TGPPen.Create(aclBlack);
  LGPPen.SetDashStyle(DashStyleDash);
  LObjRect := MakeRect(LPoints[0].X,
                       LPoints[0].Y,
                       LPoints[1].X - LPoints[0].X,
                       LPoints[1].Y - LPoints[0].Y);
   LGPGraphic.DrawRectangle(LGPPen, LObjRect);

  //CreateIuWFNg͉
  LGPPen.Free;
  LGPImage.Free;
  LGPGraphic.Free;
end;

end.
